Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Weak::ARC4_Base Class Reference

ARC4 base class. More...

Inheritance diagram for Weak::ARC4_Base:

## Public Types
typedef SymmetricCipherFinal< ARC4_Base > | Encryption
typedef SymmetricCipherFinal< ARC4_Base > | Decryption
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Public Types inherited from SymmetricCipherDocumentation
typedef SymmetricCipher | Encryption
| implements the SymmetricCipher interface
typedef SymmetricCipher | Decryption
| implements the SymmetricCipher interface

## Public Member Functions
void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes. More...
void | DiscardBytes (size_t n)
| Generate and discard n bytes. More...
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes. More...
bool | IsRandomAccess () const
| Determines whether the cipher supports random access. More...
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting. More...
bool | IsForwardTransformation () const
| Determines if the cipher is being operated in its forward direction. More...
Public Member Functions inherited from RandomNumberGenerator
virtual void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values. More...
virtual bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy. More...
virtual byte | GenerateByte ()
| Generate new random byte and return it. More...
virtual unsigned int | GenerateBit ()
| Generate new random bit and return it. More...
virtual word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffUL)
| Generate a random 32 bit word in the range min to max, inclusive. More...
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| Generate random bytes into a BufferedTransformation. More...
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length. More...
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length. More...
virtual size_t | DefaultKeyLength () const =0
| Returns default key length. More...
virtual size_t | GetValidKeyLength (size_t keylength) const =0
| Returns a valid key length for the algorithm. More...
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| Provides the size of the last block. More...
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing. More...
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...

## Static Public Member Functions
static const char * | StaticAlgorithmName ()
Static Public Member Functions inherited from VariableKeyLength< 16, 1, 256 >
static size_t | StaticGetValidKeyLength (size_t keylength)
| Provides a valid key length for the algorithm provided by a static function. More...

## Additional Inherited Members
Static Public Attributes inherited from VariableKeyLength< 16, 1, 256 >
static const int | MIN_KEYLENGTH
| The minimum key length used by the algorithm provided as a constant. More...
static const int | MAX_KEYLENGTH
| The maximum key length used by the algorithm provided as a constant. More...
static const int | DEFAULT_KEYLENGTH
| The default key length used by the algorithm provided as a constant. More...
static const int | KEYLENGTH_MULTIPLE
| The key length multiple used by the algorithm provided as a constant. More...
static const int | IV_REQUIREMENT
| The default IV requirements for the algorithm provided as a constant. More...
static const int | IV_LENGTH
| The default initialization vector length for the algorithm provided as a constant. More...

## Detailed Description

ARC4 base class.

Implementations and overrides in `Base` apply to both `ENCRYPTION` and `DECRYPTION` directions

Since
  Crypto++ 3.1

Definition at line 22 of file arc4.h.

## Member Function Documentation

## ◆ GenerateBlock()

void Weak::ARC4_Base::GenerateBlock | ( | byte * | output,
|  | size_t | size
| ) |  |
| virtual

Generate random array of bytes.

Parameters

  output | the byte buffer
  size | the length of the buffer, in bytes

All generated values are uniformly distributed over the range specified within the the constraints of a particular generator.

Note
  A derived generator must override either GenerateBlock() or GenerateIntoBufferedTransformation(). They can override both, or have one call the other.

Reimplemented from RandomNumberGenerator.

Definition at line 67 of file arc4.cpp.

## ◆ DiscardBytes()

void Weak::ARC4_Base::DiscardBytes | ( | size_t | n | ) |
| virtual

Generate and discard n bytes.

Parameters

  n | the number of bytes to generate and discard

Reimplemented from RandomNumberGenerator.

Definition at line 102 of file arc4.cpp.

## ◆ ProcessData()

void Weak::ARC4_Base::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |
| virtual

Encrypt or decrypt an array of bytes.

Parameters

  outString | the output byte buffer
  inString | the input byte buffer
  length | the size of the input and output byte buffers, in bytes

ProcessData is called with a string of bytes whose size depends on MandatoryBlockSize. Either `inString == outString`, or they must not overlap.

See also
  ProcessData, ProcessLastBlock, MandatoryBlockSize, MinLastBlockSize, BlockPaddingSchemeDef, IsLastBlockSpecial

Implements StreamTransformation.

Definition at line 73 of file arc4.cpp.

## ◆ IsRandomAccess()

bool Weak::ARC4_Base::IsRandomAccess | ( |  | ) | const
| inline virtual

Determines whether the cipher supports random access.

Returns
  true if the cipher supports random access, false otherwise

Implements StreamTransformation.

Definition at line 34 of file arc4.h.

## ◆ IsSelfInverting()

bool Weak::ARC4_Base::IsSelfInverting | ( |  | ) | const
| inline virtual

Determines whether the cipher is self-inverting.

Returns
  true if the cipher is self-inverting, false otherwise

IsSelfInverting determines whether this transformation is self-inverting (e.g. xor with a keystream).

Implements StreamTransformation.

Definition at line 35 of file arc4.h.

## ◆ IsForwardTransformation()

bool Weak::ARC4_Base::IsForwardTransformation | ( |  | ) | const
| inline virtual

Determines if the cipher is being operated in its forward direction.

Returns
  true if DIR is ENCRYPTION, false otherwise

See also
  IsForwardTransformation(), IsPermutation(), GetCipherDirection()

Implements StreamTransformation.

Definition at line 36 of file arc4.h.

The documentation for this class was generated from the following files:

- arc4.h
- arc4.cpp